/**
 * NeoCD/SDL main header file
 ** Ian Micheal 2019 edit
 * 2003 Fosters
 */
 
#ifndef NEOCD_H
#define NEOCD_H

#define SAMPLE_RATE    11025
#include "SDL.h"
#include <kos.h>

#define OUTPUT(...) 
#include "types.h"
#include "cdaudio/cdaudio.h"
#include "cdrom/cdrom.h"
#include "memory/memory.h"
#include "video/video.h"
#include "input/input.h"
#include "z80/z80intrf.h"
#include "sound/sound.h"
#include "sound/streams.h"
#include "sound/2610intf.h"
#include "sound/timer.h"
#include "pd4990a.h"



#include "c68k/c68k.h"




/*-- globals ---------------------------------------------------------------*/
extern char	*neogeo_rom_memory;
extern char	*neogeo_prg_memory;
extern char	*neogeo_fix_memory;
extern char	*neogeo_spr_memory;
extern char	*neogeo_pcm_memory;

extern unsigned char neogeo_memorycard[8192]__attribute__((aligned(32)));

//extern char	*OP_ROM;

extern int      neogeo_ipl_done;
extern int FPS;
extern u32 neocd_time;

#endif /* NEOCD_H */
